!PickListClass - Class definitions
!This class manages a queue of items in Most Recently Used (MRU) order
!It uses the ABC INIClass to store and retrieve the queue to an .INI file
!It uses the ABC SelectFileClass to retrieve a pathname with the Windows File Dialog
!It may also be used to add most recently used files to a MENU  -

!ABCIncludeFile
OMIT('_EndOfInclude_',_PICKPRESENT_)
_PICKPRESENT_    EQUATE(1)

    INCLUDE('ABUTIL.INC')

PickQueue         QUEUE,TYPE
Item                CSTRING(255)             !input item: pathname, filter criteria, etc.
Order               USHORT                   !sequence number used for sorting in MRU order
                  END

SelectFilePrompt  EQUATE('Select File...')

PickListClass     CLASS,TYPE,MODULE('ABPICK.CLW'),LINK('ABPICK.CLW',_ABCLinkMode_),DLL(_ABCDllMode_)
DisposeQ            BYTE                     !DISPOSE Q on Kill (because NEWed in Init)
Feq                 SIGNED                   !the Control that displays the picklist items (SPIN, LIST, COMBO, MENU)
FileList            BYTE                     !this is a Pathname pick list--NEW a SelectFileClass
MenuFeqOffset       SIGNED,PROTECTED         !offset of CREATEd menu items
GetFile             &SelectFileClass         !SelectFileClass object to get a pathname
INIEntry            STRING(30),PRIVATE
INIMgr              &INIClass                !INIClass object
INISection          STRING(30),PRIVATE
InitialValue        CSTRING(255)             !initial picklist entry if no stored queue
MaxItems            USHORT                   !maximum number of picklist items
Q                   &PickQueue               !the picklist items
Sequence            USHORT,PRIVATE

AddSelectFilePrompt PROCEDURE                !add "Select File..." item to pick list
GetSelectedFileMenu PROCEDURE,STRING         !on EVENT:Accepted, returns selected MENU ITEM pathname
Init                PROCEDURE(INIClass INIMgr,STRING ININame,<STRING InitialItem>,<PickQueue PickQ>,<SIGNED Feq>,BYTE FileList=0)
Kill                PROCEDURE
Load                PROCEDURE                !restore pick list from INI file
RemoveDuplicate     PROCEDURE
Reset               PROCEDURE(<STRING InitialItem>)
Save                PROCEDURE                !save pick list to INI file
SetItem             PROCEDURE(<STRING Value>)!add a picklist item or move the item to the top
UpdateWindow        PROCEDURE
                  END

  _EndOfInclude_

