!PickListClass implementation code - updated for Clarion 6
   MEMBER

   MAP.
   INCLUDE('ABPICK.INC')

PickListClass.Init  PROCEDURE(INIClass INIMgr,STRING ININame,<STRING InitialItem>,<PickQueue Q>,<SIGNED Feq>,BYTE FileList=0)
  CODE
  IF OMITTED(5)
    SELF.Q&=NEW(PickQueue)
    SELF.DisposeQ=True
  ELSE
    SELF.Q&=Q
  END
  SELF.MenuFeqOffset=-1000
  SELF.INIMgr&=INIMgr
  SELF.INIEntry=ININame
  SELF.INISection=CLIP(ININame)&'s'
  SELF.Feq=Feq
  IF InitialItem THEN SELF.InitialValue=InitialItem.
  SELF.FileList=FileList
  IF SELF.FileList
    SELF.GetFile&=NEW(SelectFileClass)
    SELF.GetFile.Init
    SELF.GetFile.DefaultFile=SELF.InitialValue
    SELF.GetFile.Flags=FILE:LongName
  END
  SELF.MaxItems=20
  SELF.Load

PickListClass.Kill  PROCEDURE
  CODE
  SELF.Save
  IF SELF.DisposeQ THEN DISPOSE(SELF.Q).
  IF SELF.FileList THEN DISPOSE(SELF.GetFile).

PickListClass.Load PROCEDURE
  CODE
  SELF.INIMgr.FetchQueue(CLIP(SELF.INISection),CLIP(SELF.INIEntry),SELF.Q,SELF.Q.Item,SELF.Q.Order)
  SELF.Sequence=RECORDS(SELF.Q)
  IF SELF.Sequence
    IF SELF.FileList THEN SELF.AddSelectFilePrompt.
    SORT(SELF.Q,-SELF.Q.Order)
    GET(SELF.Q,1)
    IF SELF.Feq THEN SELF.UpdateWindow.
  ELSE
    SELF.Reset(SELF.InitialValue)
  END

PickListClass.Save PROCEDURE
QCounter    USHORT
Order       USHORT
ItemCount   USHORT
  CODE
  IF SELF.FileList
    Order = RECORDS(SELF.Q)-1 !ignore the "SelectFile..." record
  ELSE
    Order = RECORDS(SELF.Q)
  END
  LOOP QCounter = 1 TO SELF.MaxItems
    GET(SELF.Q,QCounter)
    IF ERRORCODE() THEN BREAK.
    IF SELF.FileList AND SELF.Q.Item=SelectFilePrompt THEN CYCLE.
    SELF.INIMgr.Update(SELF.INISection,CLIP(SELF.INIEntry)&'_'&QCounter,SELF.Q.Item&','&Order)
    Order-=1
    ItemCount+=1
  END
  SELF.INIMgr.Update(SELF.INISection,SELF.INIEntry,ItemCount)

PickListClass.SetItem  PROCEDURE(<STRING Value>)
  CODE
  IF Value THEN SELF.Q.Item = Value.
  IF SELF.FileList AND SELF.Q.Item=SelectFilePrompt
    SELF.Q.Item=SELF.GetFile.Ask()
  END
  IF SELF.Q.Item
    SELF.RemoveDuplicate
    SELF.Sequence+=1
    SELF.Q.Order=SELF.Sequence
    ADD(SELF.Q)
    ASSERT(~ERRORCODE())
    SORT(SELF.Q,-SELF.Q.Order)
    GET(SELF.Q,1)
    IF SELF.Feq THEN SELF.UpdateWindow.
  END

PickListClass.RemoveDuplicate  PROCEDURE
Match       CSTRING(255)
QCounter    USHORT
  CODE
  Match=SELF.Q.Item
  LOOP QCounter = 1 TO RECORDS(SELF.Q)
    GET(SELF.Q,QCounter)
    ASSERT(~ERRORCODE())
    IF UPPER(Match)=UPPER(SELF.Q.Item)
      DELETE(SELF.Q)
      BREAK
    END
  END
  SELF.Q.Item=Match

PickListClass.UpdateWindow  PROCEDURE
QCounter    USHORT
  CODE
  CASE SELF.Feq{PROP:Type}
  OF CREATE:List OROF CREATE:Combo
    SELF.Feq{PROP:Selected}=POINTER(SELF.Q)
    DISPLAY(SELF.Feq)
  OF CREATE:Menu
    LOOP QCounter = 1 TO SELF.MaxItems
      GET(SELF.Q,QCounter)
      IF ERRORCODE() THEN CLEAR(SELF.Q).
      DESTROY(SELF.MenuFeqOffset+SELF.Feq+QCounter)
      IF SELF.Q.Item=SelectFilePrompt THEN CYCLE.
      IF SELF.Q.Item
        CREATE(SELF.MenuFeqOffset+SELF.Feq+QCounter,CREATE:Item,SELF.Feq)
        (SELF.MenuFeqOffset+SELF.Feq+QCounter){PROP:Text}=SELF.Q.Item
      END
    END
  OF CREATE:Spin    !not tested
    DISPLAY(SELF.Feq)
  ELSE
    ASSERT(False)   !unexpected control type
  END

PickListClass.Reset  PROCEDURE(<STRING InitialValue>)
  CODE
  FREE(SELF.Q)
  SELF.Sequence=1
  IF SELF.FileList THEN SELF.AddSelectFilePrompt.
  IF InitialValue
    SELF.Q.Item=InitialValue
    SELF.Q.Order=SELF.Sequence
    ADD(SELF.Q)
  END
  IF SELF.Feq THEN SELF.UpdateWindow.

PickListClass.AddSelectFilePrompt PROCEDURE
  CODE
  SELF.Q.Item=SelectFilePrompt
  SELF.Q.Order=0
  ADD(SELF.Q,-SELF.Q.Order)

PickListClass.GetSelectedFileMenu PROCEDURE
QCounter     USHORT
ReturnValue  STRING(255)
  CODE
  CASE ACCEPTED()
  OF SELF.MenuFeqOffset+SELF.Feq+1 TO SELF.MenuFeqOffset+SELF.Feq+SELF.MaxItems
    ReturnValue=ACCEPTED(){PROP:Text}
    SELF.SetItem(ReturnValue) !move selected item to top of list
  END
  RETURN ReturnValue