   MEMBER('calltree.clw')
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! This rebuild/reload process makes the following assumptions:
!
! Assumes analyzed CLASSes are ABC Compliant.
! Assumes Object.Method syntax--ignores Method(Object) syntax.
! Assumes "recursive" calls are actually PARENT calls, otherwise ignores recursion.
! Assumes same-named methods within a class have a similar purpose
!   and treats them as a single method--i.e. ignores parameter list--procedure overloading.
! Assumes Class properties and other datanames, if duplicated, refer to the same datatype
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   INCLUDE('ABWINDOW.INC')
   INCLUDE('ABUTIL.INC')
   INCLUDE('ABSOURCE.INC')          !Clarion Source Code Parser Class
   INCLUDE('ABPICK.INC')            !Pick List Class

   MAP
   END

Source        ClarionSourceClass
Debug         &INIClass
Selected      STRING(60)

QCounter      USHORT
StartTime     LONG

ClassQ        QUEUE
ClassID         STRING(LabelLength) !uppercase for sorting & searching
ClassName       STRING(LabelLength) !mixed case for display
ClassParent     STRING(LabelLength) !uppercase - maps to ClassID
ClassModule     STRING(LabelLength) !for source code viewer
              END

MethodQ       QUEUE                 !contains all methods and their attributes
MethodID        STRING(LabelLength) !uppercase for sorting & searching
ClassID         STRING(LabelLength) !uppercase for sorting & searching
MethodName      STRING(LabelLength)
ClassName       STRING(LabelLength)
PrivateMethod   BYTE
ProtectedMethod BYTE
VirtualMethod   BYTE
IsCaller        BYTE
IsCallee        BYTE
             END

AKAQ         QUEUE                  !maps object instances to their corresponding CLASS
ClassAKA       STRING(20)           !e.g. BROWSE
ClassID        STRING(LabelLength)  !e.g. BROWSECLASS
             END

LocalAKAQ    QUEUE                  !maps local object instances to their corresponding CLASS
ClassAKA       STRING(20)           !e.g. TC, FM
ClassID        STRING(LabelLength)  !e.g. TOOLBARCLASS, FILEMANAGER
             END

ModuleQ      QUEUE                  !contains implementation file names (.clw) for corresponding header (.inc) files
ModuleFile     STRING(12)
SourceQ        &SourceQueue         !the module source code--save it for 2nd pass
             END

SourceQueue  QUEUE,TYPE
Line           STRING(200)
             END

CallsQ            QUEUE
CallingClass        STRING(40)
CallingMethod       STRING(40)
CallerPrivate       BYTE
CallerProtected     BYTE
CallerVirtual       BYTE
CalledClass         STRING(40)
CalledMethod        STRING(40)
CalleePrivate       BYTE
CalleeProtected     BYTE
CalleeVirtual       BYTE
                  END

CallTreeQ         QUEUE
Method              STRING(100)
NormalFG            LONG
NormalBG            LONG
SelectedFG          LONG
SelectedBG          LONG
Level               LONG
ClassMethodKey      STRING(100)
                  END

CalledByQ         QUEUE
Method              STRING(100)
NormalFG            LONG
NormalBG            LONG
SelectedFG          LONG
SelectedBG          LONG
                  END

FindText          STRING(25)
ExactMatch        BYTE
ShowPrivate       BYTE(True)
ShowProtected     BYTE(True)
ToolTips          BYTE(True)

ManageCallTree PROCEDURE
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
LIBSRCPath           STRING(255)
ProgressMsg          STRING(255)
TitleBar             CSTRING(60)

DefaultHeadersQ      QUEUE      !For use with the DIRECTORY procedure
FileName               STRING(FILE:MaxFileName)
ShortName              STRING(13)
Date                   LONG
Time                   LONG
Size                   LONG
Attrib                 BYTE
                     END

HeaderFileQ          QUEUE      !For use with the SelectFileClass
FileName               STRING(File:MaxFilePath)
ShortName              STRING(File:MaxFilePath)
                     END

Roots                QUEUE      !root method pick list Q
Root                   CSTRING(255)
MRU                    USHORT
                     END

Find                 QUEUE      !find text pick list Q
Text                   CSTRING(255)
MRU                    USHORT
                     END
ViewerQ              QUEUE
Thread                 BYTE
                     END

PickRoot             PickListClass
PickFind             PickListClass
GetClassFiles        SelectFileClass
Popup                PopupClass
ManageCallTree       CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,VIRTUAL
Kill                   PROCEDURE(),BYTE,PROC,VIRTUAL
TakeAccepted           PROCEDURE(),BYTE,PROC,VIRTUAL
TakeFieldEvent         PROCEDURE(),BYTE,PROC,VIRTUAL
TakeWindowEvent        PROCEDURE(),BYTE,PROC,VIRTUAL
                     END
Window WINDOW('ABC Method Call Tree'),AT(,,265,230),FONT('MS Sans Serif',8,,FONT:regular),CENTER,IMM, |
         ICON('Tree.ico'),GRAY,MAX,RESIZE
       BUTTON('&ABC'),AT(3,2,22,12),USE(?ABCButton),TIP('Rebuild lists from ABC Library files')
       BUTTON('&Other Files...'),AT(29,2,,12),USE(?SelectFilesButton),TIP('Select class files to analyze')
       STRING(@s255),AT(87,4,,10),USE(ProgressMsg),TRN,FULL
       BUTTON('Help'),AT(230,2,,12),USE(?HelpButton),STD(STD:Help)
       PANEL,AT(0,17,,2),USE(?Panel),FULL,BEVEL(-1,1,09H)
       PROMPT('&Root Method:'),AT(5,23),USE(?Root:Prompt)
       COMBO(@s255),AT(54,23,160,10),USE(Roots.Root),VSCROLL,TIP('Enter or select: class.method or all'), |
           FORMAT('60L'),DROP(8),FROM(Roots)
       GROUP,AT(0,32,220,34),USE(?Group1),BOXED
         PROMPT('&Find Text:'),AT(5,40),USE(?FindPrompt)
         COMBO(@s255),AT(54,40,160,10),USE(Find.Text),VSCROLL,TIP('Enter or select: text to find'),FORMAT('60L'), |
             DROP(5),FROM(Find)
         BUTTON('Find &Next'),AT(3,51,43,12),USE(?FindNext),TIP('Find next occurence of Find text')
         CHECK('Find &whole word'),AT(53,54),USE(ExactMatch),TIP('Check for exact match; clear for contains anywhere')
       END
       BUTTON('&Expand All'),AT(3,67,43,12),USE(?ExpandAll)
       BUTTON('&Contract All'),AT(3,81,43,12),USE(?ContractAll)
       CHECK('Show &Private'),AT(53,70),USE(ShowPrivate),TIP('Include PRIVATE methods in lists')
       CHECK('Show Pro&tected'),AT(122,70),USE(ShowProtected),TIP('Include PROTECTED methods in lists')
       CHECK('Show ToolTips'),AT(198,70),USE(ToolTips),TIP('Turn off these annoying messages')
       BOX,AT(53,83,8,8),USE(?Protected:Box),COLOR(COLOR:Black),FILL(COLOR:Red)
       PROMPT('Private Method'),AT(65,83),USE(?Private:Prompt),FONT(,,COLOR:Red,)
       BOX,AT(122,83,8,8),USE(?Private:Box),COLOR(COLOR:Black),FILL(COLOR:Maroon)
       PROMPT('Protected Method'),AT(134,83),USE(?Protected:Prompt),FONT(,,COLOR:Maroon,)
       BOX,AT(198,83,8,8),USE(?Virtual:Box),COLOR(COLOR:Black),FILL(COLOR:Fuschia)
       PROMPT('Virtual Method'),AT(210,83),USE(?Virtual:Prompt),FONT(,,COLOR:Fuschia,)
       LIST,AT(1,98,,35),USE(?CallList),FULL,VSCROLL,ALRT(MouseRight),FORMAT('300L*~ called by:~L(2)'), |
           FROM(CalledByQ)
       LIST,AT(1,135),USE(?CallTree),FULL,VSCROLL,ALRT(MouseRight),FORMAT('800L*T(L)~ calls:~L(2)S(300)'), |
           FROM(CallTreeQ)
       BUTTON('Find Next'),AT(65,127),USE(?FindSelected),HIDE !for popup menu only
       BUTTON('Make Root'),AT(65,147),USE(?MakeRoot),HIDE !for popup menu only
       BUTTON('View Source'),AT(65,167),USE(?ViewSource),HIDE !for popup menu only
     END

  CODE
  GlobalResponse = ManageCallTree.Run()

ManageCallTree.Init PROCEDURE()
ReturnValue          BYTE,AUTO
  CODE
  ReturnValue = PARENT.Init()
  SELF.FirstField = ?ABCButton
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  OPEN(window)
  SELF.Opened=True
  TitleBar=window{PROP:Text}
!  Debug &=NEW(INIClass)
  INIMgr.Fetch('CallTree',Window)
  PickRoot.Init(INIMgr,'Root','WindowManager.Run',Roots,?Roots:Root)
  PickFind.Init(INIMgr,'Find',,Find,?Find:Text)
  INIMgr.Fetch('Checks','ExactMatch',ExactMatch)
  INIMgr.Fetch('Checks','ShowPrivate',ShowPrivate)
  INIMgr.Fetch('Checks','ShowProtected',ShowProtected)
  INIMgr.Fetch('Checks','ToolTips',ToolTips)
  INIMgr.Fetch('CallTree','Path',LIBSRCPath)
  Window{PROP:notips} = CHOOSE(~ToolTips)
  DO GetDefaultHeaders
  GetClassFiles.Init
  GetClassFiles.SetMask('Header files (*.inc)','*.inc')
  GetClassFiles.DefaultDirectory=LIBSRCPath
  GetClassFiles.WindowTitle='Select Header Files'
  Popup.Init(INIMgr)
  Popup.AddItemMimic('Find Next',?FindSelected)
  Popup.AddItemMimic('Make Root',?MakeRoot)
  Popup.AddItemMimic('View Source',?ViewSource)
  SELF.SetAlerts()
  Access:SaveQs.UseFile()
  Access:SourceIn.UseFile()
  DO LoadClassQ                                     !reload from last session
  DO LoadMethodQ                                    !reload from last session
  DO LoadCallsQ                                     !reload from last session
  DO LoadTreeQ                                      !reload from last session
  IF RECORDS(CallsQ)
    ?CallTree{PROPLIST:Header}=UPPER(CLIP(Roots.Root))&' calls:'
    ?CallList{PROPLIST:Header}=UPPER(CLIP(Roots.Root))&' is called by:'
    SELECT(?CallTree,1)
    POST(EVENT:NewSelection,?CallTree)
  ELSE
    POST(EVENT:Accepted,?ABCButton)
  END
  RETURN ReturnValue

GetDefaultHeaders  ROUTINE
  IF NOT LIBSRCPath
    LIBSRCPath=GETINI('Clarion 6.0  Enterprise Edition','workdir')
    p#=INSTRING('\BIN\',UPPER(CLIP(LIBSRCPath)),1,1)
    LIBSRCPath[p# : p#+8]='\libsrc\'
  END
  DIRECTORY(DefaultHeadersQ,CLIP(LIBSRCPath)&'ab*.inc',ff_:Normal)
  window{PROP:Text}=TitleBar&' ('&CLIP(LIBSRCPath)&'ab*.inc)'

LoadClassQ ROUTINE
  Access:SaveQs.SetName('.\ClassQ.Q')
  IF Access:SaveQs.TryOpen() = Level:Benign
    SET(SaveQs)
    LOOP
      IF Access:SaveQs.Next() = Level:Benign
        ClassQ.ClassID         = ClassGroup.ClassID
        ClassQ.ClassName       = ClassGroup.ClassName
        ClassQ.ClassParent     = ClassGroup.ClassParent
        ClassQ.ClassModule     = ClassGroup.ClassModule
        ADD(ClassQ)
      ELSE
        BREAK
      END
    END
    Access:SaveQs.Close
  END
  SORT(ClassQ,ClassQ.ClassID)

LoadMethodQ ROUTINE
  Access:SaveQs.SetName('.\MethodQ.Q')
  IF Access:SaveQs.TryOpen() = Level:Benign
    SET(SaveQs)
    LOOP
      IF Access:SaveQs.Next() = Level:Benign
        MethodQ.MethodID        = MethodGroup.MethodID
        MethodQ.ClassID         = MethodGroup.ClassID
        MethodQ.MethodName      = MethodGroup.MethodName
        MethodQ.ClassName       = MethodGroup.ClassName
        MethodQ.PrivateMethod   = MethodGroup.PrivateMethod
        MethodQ.ProtectedMethod = MethodGroup.ProtectedMethod
        MethodQ.VirtualMethod   = MethodGroup.VirtualMethod
        MethodQ.IsCaller        = MethodGroup.IsCaller
        MethodQ.IsCallee        = MethodGroup.IsCallee
        ADD(MethodQ)
      ELSE
        BREAK
      END
    END
    Access:SaveQs.Close
  END
  SORT(MethodQ,MethodQ.MethodID,MethodQ.ClassID)

LoadCallsQ ROUTINE
  Access:SaveQs.SetName('.\CallsQ.Q')
  IF Access:SaveQs.TryOpen() = Level:Benign
    SET(SaveQs)
    LOOP
      IF Access:SaveQs.Next() = Level:Benign
        CallsQ.CallingClass    = CallsGroup.CallingClass
        CallsQ.CallingMethod   = CallsGroup.CallingMethod
        CallsQ.CallerPrivate   = CallsGroup.CallerPrivate
        CallsQ.CallerProtected = CallsGroup.CallerProtected
        CallsQ.CallerVirtual   = CallsGroup.CallerVirtual

        CallsQ.CalledClass     = CallsGroup.CalledClass
        CallsQ.CalledMethod    = CallsGroup.CalledMethod
        CallsQ.CalleePrivate   = CallsGroup.CalleePrivate
        CallsQ.CalleeProtected = CallsGroup.CalleeProtected
        CallsQ.CalleeVirtual   = CallsGroup.CalleeVirtual
        ADD(CallsQ)
      ELSE
        BREAK
      END
    END
    Access:SaveQs.Close
  END
  SORT(CallsQ,CallsQ.CallingClass,CallsQ.CallingMethod,CallsQ.CalledClass,CallsQ.CalledMethod)

LoadTreeQ ROUTINE
  Access:SaveQs.SetName('.\TreeQ.Q')
  IF Access:SaveQs.TryOpen() = Level:Benign
    SET(SaveQs)
    LOOP
      IF Access:SaveQs.Next() = Level:Benign
        CallTreeQ.Method         = TreeGroup.Method
        CallTreeQ.NormalFG       = DEFORMAT(TreeGroup.NormalFG)
        CallTreeQ.NormalBG       = DEFORMAT(TreeGroup.NormalBG)
        CallTreeQ.SelectedFG     = DEFORMAT(TreeGroup.SelectedFG)
        CallTreeQ.SelectedBG     = DEFORMAT(TreeGroup.SelectedBG)
        CallTreeQ.Level          = DEFORMAT(TreeGroup.Level,@n-010)
        CallTreeQ.ClassMethodKey = TreeGroup.ClassMethodKey
        ADD(CallTreeQ)
      ELSE
        BREAK
      END
    END
    Access:SaveQs.Close
  END

ManageCallTree.Kill PROCEDURE()
ReturnValue          BYTE,AUTO
  CODE
  ReturnValue = PARENT.Kill()
  IF SELF.Opened
    INIMgr.Update('CallTree',window)
    INIMgr.Update('CallTree','Path',LIBSRCPath)
    INIMgr.Update('Checks','ExactMatch',ExactMatch)
    INIMgr.Update('Checks','ShowPrivate',ShowPrivate)
    INIMgr.Update('Checks','ShowProtected',ShowProtected)
    INIMgr.Update('Checks','ToolTips',ToolTips)
    PickRoot.Kill
    PickFind.Kill
    DO CloseViewers
  END
  Popup.Kill
  DO SaveClassQ                                 !Save for next session
  DO SaveMethodQ                                !Save for next session
  DO SaveCallsQ                                 !Save for next session
  DO SaveTreeQ                                  !Save for next session
  IF NOT (Debug&=NULL) THEN DISPOSE(Debug).
  RETURN ReturnValue

CloseViewers ROUTINE
  LOOP QCounter = 1 TO RECORDS(ViewerQ)
    GET(ViewerQ,QCounter)
    POST(EVENT:CloseWindow,,ViewerQ.Thread)
  END

SaveClassQ ROUTINE
  Access:SaveQs.SetName('.\ClassQ.Q')
  IF Access:SaveQs.TryOpen() = Level:Benign
    EMPTY(SaveQs)
    CLEAR(SAV:SourceLine)
    LOOP QCounter = 1 TO RECORDS(ClassQ)
      GET(ClassQ,QCounter)
      ClassGroup.ClassID          = ClassQ.ClassID
      ClassGroup.ClassName        = ClassQ.ClassName
      ClassGroup.ClassParent      = ClassQ.ClassParent
      ClassGroup.ClassModule      = ClassQ.ClassModule
      Access:SaveQs.Insert()
    END
    Access:SaveQs.Close
  END
  FREE(ClassQ)

SaveMethodQ ROUTINE
  Access:SaveQs.SetName('.\MethodQ.Q')
  IF Access:SaveQs.TryOpen() = Level:Benign
    EMPTY(SaveQs)
    CLEAR(SAV:SourceLine)
    LOOP QCounter = 1 TO RECORDS(MethodQ)
      GET(MethodQ,QCounter)
      MethodGroup.MethodID        = MethodQ.MethodID
      MethodGroup.ClassID         = MethodQ.ClassID
      MethodGroup.MethodName      = MethodQ.MethodName
      MethodGroup.ClassName       = MethodQ.ClassName
      MethodGroup.PrivateMethod   = MethodQ.PrivateMethod
      MethodGroup.ProtectedMethod = MethodQ.ProtectedMethod
      MethodGroup.VirtualMethod   = MethodQ.VirtualMethod
      MethodGroup.IsCaller        = MethodQ.IsCaller
      MethodGroup.IsCallee        = MethodQ.IsCallee
      Access:SaveQs.Insert()
    END
    Access:SaveQs.Close
  END
  FREE(MethodQ)

SaveCallsQ ROUTINE
  Access:SaveQs.SetName('.\CallsQ.Q')
  IF Access:SaveQs.TryOpen() = Level:Benign
    EMPTY(SaveQs)
    CLEAR(SAV:SourceLine)
    LOOP QCounter = 1 TO RECORDS(CallsQ)
      GET(CallsQ,QCounter)
      CallsGroup.CallingClass    = CallsQ.CallingClass
      CallsGroup.CallingMethod   = CallsQ.CallingMethod
      CallsGroup.CallerPrivate   = CallsQ.CallerPrivate
      CallsGroup.CallerProtected = CallsQ.CallerProtected
      CallsGroup.CallerVirtual   = CallsQ.CallerVirtual

      CallsGroup.CalledClass     = CallsQ.CalledClass
      CallsGroup.CalledMethod    = CallsQ.CalledMethod
      CallsGroup.CalleePrivate   = CallsQ.CalleePrivate
      CallsGroup.CalleeProtected = CallsQ.CalleeProtected
      CallsGroup.CalleeVirtual   = CallsQ.CalleeVirtual
      Access:SaveQs.Insert()
    END
    Access:SaveQs.Close
  END
  FREE(CallsQ)

SaveTreeQ ROUTINE
  Access:SaveQs.SetName('.\TreeQ.Q')
  IF Access:SaveQs.TryOpen() = Level:Benign
    EMPTY(SaveQs)
    CLEAR(SAV:SourceLine)
    LOOP QCounter = 1 TO RECORDS(CallTreeQ)
      GET(CallTreeQ,QCounter)
      TreeGroup.Method          = CallTreeQ.Method
      TreeGroup.NormalFG        = FORMAT(CallTreeQ.NormalFG,@n-010)
      TreeGroup.NormalBG        = FORMAT(CallTreeQ.NormalBG,@n-010)
      TreeGroup.SelectedFG      = FORMAT(CallTreeQ.SelectedFG,@n-010)
      TreeGroup.SelectedBG      = FORMAT(CallTreeQ.SelectedBG,@n-010)
      TreeGroup.Level           = FORMAT(CallTreeQ.Level,@n-010)
      TreeGroup.ClassMethodKey  = CallTreeQ.ClassMethodKey
      Access:SaveQs.Insert()
    END
    Access:SaveQs.Close
  END
  FREE(CallTreeQ)

ManageCallTree.TakeWindowEvent PROCEDURE()
  CODE
  CASE EVENT()
  OF EVENT:Sized
    ?CallTree{PROP:Height}=0{PROP:Height}-?CallTree{PROP:YPos}-1 
    ?HelpButton{PROP:XPos}=0{PROP:Width}-?HelpButton{PROP:Width}-3
  END
  RETURN PARENT.TakeWindowEvent()

ManageCallTree.TakeFieldEvent PROCEDURE()
FirstPass BYTE(True),STATIC
  CODE
  CASE FIELD()
  OF ?CallList
    CASE EVENT()
    OF EVENT:AlertKey
      IF KEYCODE() = MouseRight
        GET(CalledByQ,CHOICE(?CallList))
        Selected=CalledByQ.Method
        Popup.Ask
      END
    END
  OF ?CallTree
    CASE EVENT()
    OF EVENT:NewSelection
      GET(CallTreeQ,CHOICE(?CallTree))
      IF NOT ERRORCODE()
        BuildCalledByQ(CallTreeQ.ClassMethodKey,?CallList)
      END
    OF EVENT:AlertKey
      IF KEYCODE() = MouseRight !at present, the Runtime Library doesnot select the right-clicked item
!this only works if list is fully expanded: SELECT(?CallTree,?CallTree{PROP:VScrollPos}+INT((MOUSEY()-?CallTree{PROP:YPos})/8+1))
        GET(CallTreeQ,CHOICE(?CallTree))
        Selected=CallTreeQ.ClassMethodKey
        Popup.Ask
      END
!    OF EVENT:PreAlertKey
     !convert a right-click to a left-click+right-click so the correct list item is selected before the right-click completes
!      IF KEYCODE() = MouseRight
!        IF FirstPass
!          SETKEYCODE(0) !this doesn't seem to have any effect
!          PRESSKEY(MouseLeft)  !initiate a left-click to select the item
!          PRESSKEY(MouseRight) !initiate a right-click on the selected item
!          FirstPass=False
!          RETURN Level:Notify  !abort the EVENT:AlertKey from the first right-click
!        ELSE
!          FirstPass=True       !reset the FirstPass switch and permit the EVENT:AlertKey to proceed
!        END
!      END
    END
  END
  RETURN Level:Benign

ManageCallTree.TakeAccepted PROCEDURE()
  CODE
  CASE ACCEPTED()
  OF ?ABCButton                 !Rebuild the call hierarchy from source code
    DO PrepareToBuild 
    DO ScanHeaderFiles          !Build ClassQ, MethodQ, and AKAQ from .inc files
    DO ScanImplementationFiles  !Continue AKAQ from .clw files
    DO PruneAKAQ                !remove non-class AKAs
    DO AnalyzeMethodCalls       !Build CallsQ from other Qs
    DO SetTreeRoot              !Finish CallsQ with specified root (uncalled) methods
    DO BuildCallTreeQ           !Build CallTreeQ from CallsQ
    DO WrapUp
  OF ?SelectFilesButton
    DO GetHeaderFiles
  OF ?Roots:Root
    DO SetTreeRoot
    DO BuildCallTreeQ
  OF ?Find:Text OROF ?FindNext
    DO FindNext
  OF ?ShowPrivate OROF ?ShowProtected
    DO BuildCallTreeQ
  OF ?ToolTips
    window{PROP:notips} = CHOOSE(~ToolTips)
  OF ?ExpandAll
    DO ExpandAll
  OF ?ContractAll
    DO ContractAll
  OF ?FindSelected
    Find.Text=Selected
    POST(EVENT:Accepted,?Find:Text)
  OF ?MakeRoot
    Roots.Root=Selected
    POST(EVENT:Accepted,?Roots:Root)
  OF ?ViewSource
    DO ViewSource
  END
  RETURN PARENT.TakeAccepted()

ViewSource ROUTINE
  ClassQ.ClassID=UPPER(Selected[1 : INSTRING('.',Selected,1,1)-1])
  GET(ClassQ,ClassQ.ClassID)
  IF ERRORCODE()
    MESSAGE('Can''t find source code for '&Selected)
  ELSE
    ViewerQ.Thread=START(ViewSource,25000,CLIP(LIBSRCPath)&ClassQ.ClassModule,Selected)
    ADD(ViewerQ)
  END

FindNext ROUTINE
  DATA
Hit        BYTE
  CODE
  PickFind.SetItem
  LOOP QCounter = 1+CHOICE(?CallTree) TO RECORDS(CallTreeQ)
    GET(CallTreeQ,QCounter)
    ASSERT(~ERRORCODE())
    IF ExactMatch
      IF UPPER(CLIP(Find.Text))=CLIP(CalltreeQ.ClassMethodKey)
        Hit=True
      END
    ELSE
      Hit=INSTRING(UPPER(CLIP(Find.Text)),CLIP(CallTreeQ.ClassMethodKey),1,1)
    END
    IF Hit
      ?CallTree{PROP:Height}=1          !force presence of vertical scrollbar
      SELECT(?CallTree,QCounter)        ! which in turn forces scroll on offscreen SELECT
      ?CallTree{PROP:Height}=0{PROP:Height}-?CallTree{PROP:YPos}-1 !restore height
      POST(EVENT:NewSelection,?CallTree)!rebuild CalledByQ
      BREAK
    END
  END
  IF QCounter > RECORDS(CallTreeQ)
    CASE MESSAGE(''''&CLIP(Find.Text)&''' not found.<13,10,13,10>'&|
    'Continue search from beginning?','Search results',ICON:Question,BUTTON:Yes+BUTTON:No)
    OF BUTTON:Yes
      SELECT(?CallTree,1)
      POST(EVENT:Accepted,?Find:Text)
    END
  END

ExpandAll ROUTINE
  LOOP QCounter = 1 TO RECORDS(CallTreeQ)
    GET(CallTreeQ,QCounter)
    ASSERT(~ERRORCODE())
    CallTreeQ.Level=ABS(CallTreeQ.Level)
    PUT(CallTreeQ)
    ASSERT(~ERRORCODE())
  END

ContractAll ROUTINE
  DATA
Level   SHORT
  CODE
  LOOP QCounter = 1 TO RECORDS(CallTreeQ)
    GET(CallTreeQ,QCounter+1)
    IF ERRORCODE()
      Level=0
    ELSE
      Level=ABS(CallTreeQ.Level)
    END
    GET(CallTreeQ,QCounter)
    ASSERT(~ERRORCODE())
    IF ABS(CallTreeQ.Level)<Level           !has children
      CallTreeQ.Level= -ABS(CallTreeQ.Level)
    ELSE                                    !if no children:
      CallTreeQ.Level= ABS(CallTreeQ.Level) ! then always expanded (suppress +- expand box)
    END
    PUT(CallTreeQ)
    ASSERT(~ERRORCODE())
  END
  SELECT(?CallTree,1)
  POST(EVENT:NewSelection,?CallTree)

GetHeaderFiles ROUTINE
  GetClassFiles.Ask(HeaderFileQ,1)
  IF RECORDS(HeaderFileQ)
    GET(HeaderFileQ,1)
    ASSERT(~ERRORCODE())
    LIBSRCPath=HeaderFileQ.FileName
    LOOP i#=LEN(CLIP(LIBSRCPath)) TO 1 BY -1
      IF LIBSRCPath[i#]='\' THEN BREAK.
    END
    LIBSRCPath=LIBSRCPath[1:i#]
    GetClassFiles.DefaultDirectory=LIBSRCPath
    window{PROP:Text}=TitleBar&' ('&CLIP(HeaderFileQ.FileName)&'...)'
    POST(EVENT:Accepted,?ABCButton)
  END

PrepareToBuild ROUTINE
  SETCURSOR(Cursor:Wait)
  StartTime=CLOCK()
  FREE(ClassQ)
  FREE(MethodQ)
  FREE(AKAQ)
  FREE(CallsQ)
  FREE(CallTreeQ)
  FREE(CalledByQ)
  Source.Init(SRCIN:SourceLine)
  ?ProgressMsg{PROP:FontStyle}=FONT:Regular

ScanHeaderFiles ROUTINE
  !Build ClassQ, MethodQ, and AKAQ from each header (inc) file
  IF RECORDS(HeaderFileQ)
    LOOP QCounter=1 TO RECORDS(HeaderFileQ)
      GET(HeaderFileQ,QCounter)
      ASSERT(~ERRORCODE())
      ProgressMsg='Scanning '&HeaderFileQ.FileName
      DISPLAY(?ProgressMsg)
      BuildClassQMethodQAKAQ(HeaderFileQ.FileName)
    END
  ELSE
    LOOP QCounter=1 TO RECORDS(DefaultHeadersQ)
      GET(DefaultHeadersQ,QCounter)
      ASSERT(~ERRORCODE())
      GLO:PathName=CLIP(LIBSRCPath) & DefaultHeadersQ.FileName
      ProgressMsg='Scanning '& GLO:PathName
      DISPLAY(?ProgressMsg)
      BuildClassQMethodQAKAQ(GLO:PathName)
    END
  END

ScanImplementationFiles ROUTINE
  LOOP QCounter=1 TO RECORDS(ModuleQ)
    GET(ModuleQ,QCounter)
    ASSERT(~ERRORCODE())
    GLO:PathName=CLIP(LIBSRCPath) & ModuleQ.ModuleFile
    ProgressMsg='Scanning '& GLO:PathName
    DISPLAY(?ProgressMsg)
    BuildAKAQSourceQ(GLO:PathName)
  END

PruneAKAQ ROUTINE
  !now that classQ is complete, remove non-class AKAs
  LOOP QCounter = RECORDS(AKAQ) TO 1 BY -1
    GET(AKAQ,QCounter)
    ClassQ.ClassID=AKAQ.ClassID
    GET(ClassQ,ClassQ.ClassID)
    IF ERRORCODE()
      DELETE(AKAQ)
    END
  END
  SORT(AKAQ,AKAQ.ClassAKA)

AnalyzeMethodCalls ROUTINE
  !write calltreeQ from Qs and implementation (clw) source
  LOOP QCounter=1 TO RECORDS(ModuleQ)
    GET(ModuleQ,QCounter)
    ASSERT(~ERRORCODE())
    GLO:PathName=CLIP(LIBSRCPath) & ModuleQ.ModuleFile
    ProgressMsg='Scanning '& GLO:PathName
    DISPLAY(?ProgressMsg)
    BuildCallsQ
  END

SetTreeRoot ROUTINE
  DATA
Pos           BYTE
RootClass     STRING(30)
RootMethod    STRING(30)
  CODE
  SORT(CallsQ,CallsQ.CallingClass,CallsQ.CallingMethod,CallsQ.CalledClass,CallsQ.CalledMethod)
  Pos = INSTRING('.',Roots.Root,1,1)         !Root should be in class.method format
  IF Pos
    RootClass=UPPER(Roots.Root[1:Pos-1])
    RootMethod=UPPER(Roots.Root[Pos+1:LEN(CLIP(Roots.Root))])
  END
  IF ACCEPTED()=?ABCButton                   !rebuilding from scratch
    PickRoot.SetItem('WindowManager.Run')    !always prime picklist with Run method
    LOOP QCounter=1 TO RECORDS(CallsQ)       !find the root "left over" from prior build
      GET(CallsQ,QCounter)
      ASSERT(~ERRORCODE())
      IF UPPER(CallsQ.CallingClass)=RootClass AND UPPER(CallsQ.CallingMethod)=RootMethod
        BREAK
      END
    END
    IF UPPER(CallsQ.CallingClass)=RootClass AND UPPER(CallsQ.CallingMethod)=RootMethod
      MethodQ.ClassID=RootClass              !if "leftover" root found, then write it
      MethodQ.MethodID=RootMethod
      GET(MethodQ,MethodQ.MethodID,MethodQ.ClassID)
      ASSERT(~ERRORCODE())
      ?CallTree{PROPLIST:Header}=UPPER(CLIP(Roots.Root))&' calls:'
      DO WriteRoot
    ELSE
      DO AllRoots
    END
  ELSE                                       !not rebuilding, just selecting a new root method
    DO DeleteRoots                           !show only the requested root
    CASE UPPER(Roots.Root)
    OF 'ALL' OROF ''
      DO AllRoots
    ELSE
      ?CallTree{PROPLIST:Header}=UPPER(CLIP(Roots.Root))&' calls:'
      LOOP QCounter=1 TO RECORDS(CallsQ)       !find the requested root
        GET(CallsQ,QCounter)
        ASSERT(~ERRORCODE())
        IF UPPER(CallsQ.CallingClass)=RootClass AND UPPER(CallsQ.CallingMethod)=RootMethod
          BREAK
        END
      END
      IF UPPER(CallsQ.CallingClass)=RootClass AND UPPER(CallsQ.CallingMethod)=RootMethod
        MethodQ.ClassID=RootClass                !if requested root found, then write it
        MethodQ.MethodID=RootMethod
        GET(MethodQ,MethodQ.MethodID,MethodQ.ClassID)
        ASSERT(~ERRORCODE())
        DO WriteRoot
      END
    END
  END

AllRoots ROUTINE
  LOOP QCounter=1 TO RECORDS(MethodQ)
    GET(MethodQ,QCounter)
    ASSERT(~ERRORCODE())
    IF (MethodQ.IsCaller AND (NOT MethodQ.IsCallee))
      LOOP i#=1 TO RECORDS(CallsQ)              !Find the root method in the CallsQ
        GET(CallsQ,i#)
        IF UPPER(CallsQ.CallingClass)=MethodQ.ClassID AND UPPER(CallsQ.CallingMethod)=MethodQ.MethodID
          BREAK
        END
      END
      IF UPPER(CallsQ.CallingClass)=MethodQ.ClassID AND UPPER(CallsQ.CallingMethod)=MethodQ.MethodID
        DO WriteRoot                                                      
      END
    END
  END
  GET(CallsQ,1)
  ASSERT(~ERRORCODE())
  IF CallsQ.CallingClass                        !No true root (uncalled) methods
    LOOP i#=1 TO RECORDS(CallsQ)                !stuff the pick list caller methods
      GET(CallsQ,i#)                            ! i.e. all CallsQ items
      PickRoot.SetItem(CLIP(CallsQ.CallingClass)&'.'&CallsQ.CallingMethod)
    END
  ELSE
    PickRoot.SetItem('All')                     !Make "All" the current pick list item.
  END
  ?CallList{PROPLIST:Header}='... is called by:'
  ?CallTree{PROPLIST:Header}='... calls:'

WriteRoot ROUTINE
  CallsQ.CallingMethod=''
  CallsQ.CallingClass=''
  CallsQ.CalledClass=MethodQ.ClassName
  CallsQ.CalledMethod=MethodQ.MethodName
  CallsQ.CalleePrivate=MethodQ.PrivateMethod
  CallsQ.CalleeProtected=MethodQ.ProtectedMethod
  CallsQ.CalleeVirtual=MethodQ.VirtualMethod
  GET(CallsQ,CallsQ.CallingClass,CallsQ.CallingMethod,CallsQ.CalledClass,CallsQ.CalledMethod)
  IF ERRORCODE()
    ADD(CallsQ,CallsQ.CallingClass,CallsQ.CallingMethod,CallsQ.CalledClass,CallsQ.CalledMethod)
    ASSERT(~ERRORCODE())
  ELSE
    PUT(CallsQ)
    ASSERT(~ERRORCODE())
  END
  PickRoot.SetItem(CLIP(CallsQ.CalledClass)&'.'&CallsQ.CalledMethod) !stuff picklist with valid root

DeleteRoots ROUTINE
  LOOP QCounter = 1 TO RECORDS(CallsQ)
    GET(CallsQ,QCounter)
    IF CallsQ.CallingClass
      BREAK
    ELSE
      DELETE(CallsQ)
      QCounter-=1
    END
  END

BuildCallTreeQ ROUTINE
  DATA
ParentPos USHORT
  CODE
  SETCURSOR(Cursor:Wait)
  ?ProgressMsg{PROP:FontStyle}=FONT:Regular
  FREE(CallTreeQ)
  SORT(CallsQ,CallsQ.CallingClass,CallsQ.CallingMethod)
  LOOP QCounter = 1 TO RECORDS(CallsQ)
    GET(CallsQ,QCounter)
    IF CallsQ.CallingClass THEN BREAK.          !process root methods only
    IF (~ShowPrivate) AND CallsQ.CalleePrivate THEN CYCLE.
    IF (~ShowProtected) AND CallsQ.CalleeProtected THEN CYCLE.
    ProgressMsg='Expanding '&CallsQ.CalledClass&CallsQ.CalledMethod
    DISPLAY(?ProgressMsg)
    CallTreeQ.Level=-1                          !build tree in contracted state
    CallTreeQ.Method=CLIP(CallsQ.CalledClass)&'.'&CallsQ.CalledMethod
    CallTreeQ.ClassMethodKey=UPPER(CallTreeQ.Method)
    SetColor(CallTreeQ.NormalBG,CallTreeQ.SelectedBG,CallTreeQ.NormalFG,CallTreeQ.SelectedFG,CallsQ.CalleePrivate,CallsQ.CalleeVirtual,CallsQ.CalleeProtected)
    ADD(CallTreeQ)
    ASSERT(~ERRORCODE())
    ParentPos=POINTER(CallTreeQ)
    IF ~AddChildren(CallsQ.CalledClass,CallsQ.CalledMethod,CallTreeQ.Level)!expand each root method
      GET(CallTreeQ,ParentPos)
      ASSERT(~ERRORCODE())
      DELETE(CallTreeQ)                         !if no children (because private, etc.), remove root
      ASSERT(~ERRORCODE())
    END
  END
  IF RECORDS(CallTreeQ)
    SELECT(?CallTree,1)
    POST(EVENT:NewSelection,?CallTree)          !rebuilds the CalledByQ
  ELSE
    BuildCalledByQ(Roots.Root,?CallList)
    SELECT(?Roots:Root)
    PRESSKEY(DownKey)                           !drop down the roots picklist
    BEEP
  END
  ProgressMsg='Done!'
  SETCURSOR()

WrapUp ROUTINE
  ProgressMsg='Done! (Scan time: '&(CLOCK()-StartTime)/100&' seconds)'
  ?ProgressMsg{PROP:FontStyle}=FONT:Bold
  IF NOT (Debug&=NULL) THEN DO WriteDebugQs.
  Source.Kill
  LOOP QCounter = 1 TO RECORDS(ModuleQ)
    GET(ModuleQ,QCounter)
    ASSERT(~ERRORCODE())
    IF ~(ModuleQ.SourceQ&=NULL)
      DISPOSE(ModuleQ.SourceQ)
    END
  END
  FREE(ModuleQ)
!  FREE(ClassQ)
  FREE(AKAQ)
  FREE(HeaderFileQ)

WriteDebugQs ROUTINE
  !AKAQ (global & local)
  Debug.Init('./QAKAQ.Q')
  Debug.Update('AKAQ','Items',RECORDS(AKAQ))
  LOOP QCounter = 1 TO RECORDS(AKAQ)
    GET(AKAQ,QCounter)
    Debug.Update('AKAQ','_'&QCounter,CLIP(AKAQ.ClassAKA)&','&AKAQ.ClassID)
  END
  Debug.Update('LocalAKAQ','Items',RECORDS(LocalAKAQ))
  LOOP QCounter = 1 TO RECORDS(LocalAKAQ)
    GET(LocalAKAQ,QCounter)
    Debug.Update('LocalAKAQ','_'&QCounter,CLIP(LocalAKAQ.ClassAKA)&','&LocalAKAQ.ClassID)
  END
  !ClassQ, MethodQ, CallsQ and CallTreeQ: see LoadQueues and SaveQueues

BuildCalledByQ PROCEDURE(STRING Callee,SIGNED CallList)
Hit BYTE
  CODE
  FREE(CalledByQ)
  CallList{PROPLIST:Header}=CLIP(Callee)&' is called by:'
  IF UPPER(Callee) = 'ALL' THEN RETURN False.
  SORT(CallsQ,CallsQ.CalledClass,CallsQ.CalledMethod)
  LOOP QCounter = 1 TO RECORDS(CallsQ)
    GET(CallsQ,QCounter)
    ASSERT(~ERRORCODE())
    IF CallsQ.CallingMethod AND UPPER(CLIP(CallsQ.CalledClass)&'.'&CLIP(CallsQ.CalledMethod))=UPPER(CLIP(Callee))
      Hit=True
      IF (~ShowPrivate) AND CallsQ.CallerPrivate THEN CYCLE.
      IF (~ShowProtected) AND CallsQ.CallerProtected THEN CYCLE.
      CalledByQ.Method=CLIP(CallsQ.CallingClass)&'.'&CallsQ.CallingMethod
      SetColor(CalledByQ.NormalBG,CalledByQ.SelectedBG,CalledByQ.NormalFG,CalledByQ.SelectedFG,CallsQ.CallerPrivate,CallsQ.CallerVirtual,CallsQ.CallerProtected)
      ADD(CalledByQ)
      ASSERT(~ERRORCODE())
    ELSE
      IF Hit THEN BREAK.
    END
  END
  RETURN Hit

BuildClassQMethodQAKAQ PROCEDURE (STRING SourceFile)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  CODE
  CLEAR(ClassQ)
  Access:SourceIn.SetName(SourceFile)
  IF Access:SourceIn.TryOpen() = Level:Benign
    SET(SourceIn)
    LOOP
      IF Access:SourceIn.Next() = Level:Benign
        CASE Source.TakeLine()
        OF Source:DeclaresClass
          DO SetClass
          DO SetModule
        OF Source:DeclaresProcedure
          DO SetMethod
        OF Source:Other
          SetAKA
        END
      ELSE
        BREAK
      END
    END
    Access:SourceIn.Close
  END

SetCLASS ROUTINE
  ClassQ.ClassName=Source.Label
  ClassQ.ClassID=UPPER(Source.Label)
  ClassQ.ClassParent=UPPER(Source.ParentClass)
  ClassQ.ClassModule=UPPER(Source.ModuleName)
  MethodQ.ClassName=Source.Label
  MethodQ.ClassID=UPPER(Source.Label)
  ADD(ClassQ,ClassQ.ClassID)
  IF ERRORCODE() THEN STOP(ERROR()).

SetModule ROUTINE
  ASSERT(Source.ModuleName)
  ModuleQ.ModuleFile = UPPER(Source.ModuleName)
  GET(ModuleQ,ModuleQ.ModuleFile)
  IF ERRORCODE()
    ModuleQ.SourceQ &= NULL
    ADD(ModuleQ,ModuleQ.ModuleFile)
    ASSERT(~ERRORCODE())
  END

SetMethod ROUTINE
  IF ~ClassQ.ClassID THEN EXIT.
  MethodQ.MethodName=Source.Label
  MethodQ.MethodID=UPPER(Source.Label)
  MethodQ.PrivateMethod=CHOOSE(0<>INSTRING('PRIVATE',UPPER(CLIP(SRCIN:SourceLine)),1,1),1,0)
  MethodQ.ProtectedMethod=CHOOSE(0<>INSTRING('PROTECTED',UPPER(CLIP(SRCIN:SourceLine)),1,1),1,0)
  MethodQ.VirtualMethod=CHOOSE(0<>INSTRING('VIRTUAL',UPPER(CLIP(SRCIN:SourceLine)),1,1),1,0)
  GET(MethodQ,MethodQ.MethodID,MethodQ.ClassID)
  IF ERRORCODE()
    ADD(MethodQ,MethodQ.MethodID,MethodQ.ClassID)
    IF ERRORCODE() THEN STOP(ERROR()).
  END

SetAKA        PROCEDURE
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
DataType      STRING(LabelLength)
  CODE
  IF ~Source.Label THEN RETURN.
  Source.NextWord()                        !skip 1st word (label)
  DataType=UPPER(Source.NextWord())
  IF LEFT(Source.GetLeftDelimiter()) = '&' !look for references to other data structures
    CASE DataType
    OF 'WINDOW' OROF 'FILE' OROF 'STRING' OROF 'CSTRING' OROF 'PSTRING' OROF 'LONG' |
    OROF 'ULONG' OROF 'SHORT' OROF 'USHORT' OROF 'BYTE' OROF 'QUEUE' OROF 'SIGNED' |
    OROF 'UNSIGNED' OROF 'VIEW' OROF 'KEY' OROF 'GROUP' OROF 'ANY' OROF 'DECIMAL' |
    OROF 'BFLOAT4' OROF 'BFLOAT8' OROF 'REAL' OROF 'PDECIMAL' OROF 'DATE' OROF 'TIME'
      RETURN                               !we don't care about references to native datatypes
    END
    AKAQ.ClassAKA = UPPER(Source.Label)
    AKAQ.ClassID = DataType
    GET(AKAQ,AKAQ.ClassAKA,AKAQ.ClassID)
    IF ERRORCODE()
      ADD(AKAQ)
      ASSERT(~ERRORCODE())
    END
  END

BuildAKAQSourceQ PROCEDURE (STRING SourceFile)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Continued BYTE
  CODE
  Access:SourceIn.SetName(SourceFile)
  IF Access:SourceIn.TryOpen() = Level:Benign
    ModuleQ.SourceQ &= NEW(SourceQueue)
    PUT(ModuleQ)
    ASSERT(~ERRORCODE())
    SET(SourceIn)
    LOOP
      IF Access:SourceIn.Next() = Level:Benign
        CASE Source.TakeLine()
        OF Source:DeclaresProcedure !no more data declarations
          LOOP                      !save source code for 2nd pass
            IF SourceIn.LabelExists OR INSTRING('.',CLIP(SourceIn.SourceLine),1,2) OR Continued OR INSTRING('|',CLIP(SourceIn.SourceLine),1,2)
              ModuleQ.SourceQ.Line=CLIP(SourceIn.SourceLine)
              ADD(ModuleQ.SourceQ)
              ASSERT(~ERRORCODE())
            END
            IF INSTRING('|',CLIP(SourceIn.SourceLine),1,2)
              Continued=True
            ELSE
              Continued=False
            END
            IF Access:SourceIn.Next() THEN BREAK.
          END
          BREAK
        OF Source:IsBlank OROF Source:IsComment OROF Source:IsContinued
        ELSE
          SetAKA
        END
      ELSE
        BREAK
      END
    END
    Access:SourceIn.Close
  END

BuildCallsQ PROCEDURE
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
HoldClass       STRING(LabelLength)
HoldMethod      STRING(LabelLength)
CallerMethod    USHORT 
CalleeMethod    USHORT
Counter         LONG
  CODE
  LOOP Counter = 1 TO RECORDS(ModuleQ.SourceQ)
    GET(ModuleQ.SourceQ,Counter)
    ASSERT(~ERRORCODE())
    CASE Source.TakeLine(ModuleQ.SourceQ.Line)
    OF Source:DeclaresProcedure
      DO CheckForCaller
    OF Source:Other
      IF CallerMethod THEN DO CheckForCallee.
    END
  END

CheckForCaller ROUTINE
  IF INSTRING('.',Source.Label,1,1)
    CallsQ.CallingClass=Source.NextWord()
    CallsQ.CallingMethod=Source.NextWord()
    DO SetCallerAttributes
    DO BuildLocalAKAQ
  ELSE
    CallerMethod=False
  END

SetCallerAttributes ROUTINE
  MethodQ.ClassID=UPPER(CallsQ.CallingClass)
  MethodQ.MethodID=UPPER(CallsQ.CallingMethod)
  GET(MethodQ,MethodQ.MethodID,MethodQ.ClassID)
  IF ERRORCODE()
    CallerMethod=False !this is not a method of a class
  ELSE
    CallsQ.CallerPrivate=MethodQ.PrivateMethod
    CallsQ.CallerProtected=MethodQ.ProtectedMethod
    CallsQ.CallerVirtual=MethodQ.VirtualMethod
    CallerMethod=POINTER(MethodQ)
  END

BuildLocalAKAQ ROUTINE
!This routine handles Classes referenced in the method's parameter list
  DATA
ClassID STRING(LabelLength)
AKA     STRING(LabelLength)
  CODE
  FREE(LocalAKAQ)
  Source.StartScan=0
  LOOP WHILE Source.NextDataLabelPair(ClassID,AKA)
    ClassQ.ClassID=UPPER(ClassID)
    GET(ClassQ,ClassQ.ClassID)
    IF NOT ERRORCODE()
      LocalAKAQ.ClassAKA=UPPER(AKA)
      LocalAKAQ.ClassID=ClassQ.ClassID
      ADD(LocalAKAQ,LocalAKAQ.ClassAKA)
      ASSERT(~ERRORCODE())
    END
  END

CheckForCallee ROUTINE
  !Search the source line for any called methods
  !Assume Object.Method syntax--ignore Method(Object) syntax
  IF Source.Label
    DO MoreLocalAKAQ
  ELSE
    LOOP WHILE Source.NextWordDotWordPair(HoldClass,HoldMethod)
      CallsQ.CalledClass=HoldClass   !store mixed case name in case we can't resolve the class name.
      CallsQ.CalledMethod=HoldMethod !store mixed case name for display purposes
      HoldClass=UPPER(HoldClass)
      HoldMethod=UPPER(HoldMethod)
      DO VerifyMethod
    END
  END

MoreLocalAKAQ ROUTINE
!This routine handles Classes referenced in the method's data section
  LocalAKAQ.ClassAKA=UPPER(Source.NextWord())
  ClassQ.ClassID=UPPER(Source.NextWord())
  GET(ClassQ,ClassQ.ClassID)
  IF NOT ERRORCODE()
    LocalAKAQ.ClassID=ClassQ.ClassID
    ADD(LocalAKAQ,LocalAKAQ.ClassAKA)
    ASSERT(~ERRORCODE())
  END

VerifyMethod ROUTINE
  MethodQ.MethodID=HoldMethod
  GET(MethodQ,MethodQ.MethodID)
  IF NOT ERRORCODE()       !this -is- a method call (not a property reference)
    CalleeMethod=False     !haven't identified the specific callee yet
    DO SetClassName        !figure out what class the method belongs to
    DO SetCalleeAttributes
    DO WriteCallsQ
    DO MarkCallingMethod
  END

SetClassName ROUTINE
  CASE HoldClass
  OF 'SELF'
    CallsQ.CalledClass=CallsQ.CallingClass
    MethodQ.ClassID=UPPER(CallsQ.CalledClass)
    MethodQ.MethodID=HoldMethod
    GET(MethodQ,MethodQ.MethodID,MethodQ.ClassID)
    IF ERRORCODE()       !must be an inherited method
      ClassQ.ClassID=UPPER(CallsQ.CallingClass)
      DO CheckAncestors  !look at parent class
    ELSE
      IF UPPER(CLIP(CallsQ.CallingClass)&CLIP(CallsQ.CallingMethod)) = CLIP(MethodQ.ClassID)&CLIP(MethodQ.MethodID)
        DO CheckAncestors !assume "recursive" call is actually a parent call (only appears recursive because we are ignoring method prototypes)
      ELSE
        CalleeMethod=POINTER(MethodQ) !this is the specific method called
      END
    END
  OF 'PARENT'
    ClassQ.ClassID=UPPER(CallsQ.CallingClass)
    DO CheckAncestors
  ELSE !look for class AKA
    DO CheckLocalAKAs
    DO CheckAKAs
  END

CheckAncestors ROUTINE
!look thru parent classes for inherited method
  GET(ClassQ,ClassQ.ClassID)
  IF ERRORCODE() THEN EXIT.
  LOOP WHILE ClassQ.ClassParent
    ClassQ.ClassID=ClassQ.ClassParent
    GET(ClassQ,ClassQ.ClassID)
    IF ERRORCODE()
      BREAK
    ELSE
      MethodQ.ClassID=ClassQ.ClassID
      MethodQ.MethodID=HoldMethod
      GET(MethodQ,MethodQ.MethodID,MethodQ.ClassID)
      IF NOT ERRORCODE()
        CallsQ.CalledClass=MethodQ.ClassName
        CalleeMethod=POINTER(MethodQ) !this is the specific method called
        BREAK
      END
    END
  END

CheckLocalAKAs ROUTINE
  LocalAKAQ.ClassAKA=HoldClass
  GET(LocalAKAQ,LocalAKAQ.ClassAKA)
  IF NOT ERRORCODE()
    MethodQ.ClassID=LocalAKAQ.ClassID
    MethodQ.MethodID=HoldMethod
    GET(MethodQ,MethodQ.MethodID,MethodQ.ClassID)
    IF ERRORCODE()
      ClassQ.ClassID=LocalAKAQ.ClassID
      DO CheckAncestors
    ELSE
      CallsQ.CalledClass=MethodQ.ClassName
      CalleeMethod=POINTER(MethodQ) !this is the specific method called
    END
  END

CheckAKAs ROUTINE
  IF CalleeMethod THEN EXIT. !specific callee already identified
  AKAQ.ClassAKA=HoldClass
  GET(AKAQ,AKAQ.ClassAKA)
  IF NOT ERRORCODE()
    MethodQ.ClassID=AKAQ.ClassID
    MethodQ.MethodID=HoldMethod 
    GET(MethodQ,MethodQ.MethodID,MethodQ.ClassID)
    IF ERRORCODE()
      ClassQ.ClassID=AKAQ.ClassID
      DO CheckAncestors
    ELSE
      CallsQ.CalledClass=MethodQ.ClassName
      CalleeMethod=POINTER(MethodQ) !this is the specific method called
    END
  END

SetCalleeAttributes ROUTINE
  IF CalleeMethod
    GET(MethodQ,CalleeMethod)
    ASSERT(~ERRORCODE())
    CallsQ.CalleePrivate=MethodQ.PrivateMethod
    CallsQ.CalleeProtected=MethodQ.ProtectedMethod
    CallsQ.CalleeVirtual=MethodQ.VirtualMethod
    MethodQ.IsCallee=True
    PUT(MethodQ)
    ASSERT(~ERRORCODE())
  END

WriteCallsQ ROUTINE
  IF CLIP(CallsQ.CallingClass)&CLIP(CallsQ.CallingMethod) <> CLIP(CallsQ.CalledClass)&CLIP(CallsQ.CalledMethod) !ignore recursive call
    GET(CallsQ,CallsQ.CallingClass,CallsQ.CallingMethod,CallsQ.CalledClass,CallsQ.CalledMethod)
    IF ERRORCODE()
      ADD(CallsQ,CallsQ.CallingClass,CallsQ.CallingMethod,CallsQ.CalledClass,CallsQ.CalledMethod)
      ASSERT(~ERRORCODE())
    ELSE
      PUT(CallsQ)
      ASSERT(~ERRORCODE())
    END
  END

MarkCallingMethod ROUTINE
  IF CallerMethod
    GET(MethodQ,CallerMethod)
    ASSERT(~ERRORCODE())
    MethodQ.IsCaller=True
    PUT(MethodQ)
    ASSERT(~ERRORCODE())
  END

AddChildren PROCEDURE(STRING CallerClass, STRING CallerMethod, SHORT Level)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
i           USHORT
Children    BYTE
ParentPos   USHORT
  CODE
  Level-=1        !building Q in contracted state, therefore decrement level
  CallsQ.CallingClass=CallerClass
  CallsQ.CallingMethod=CallerMethod
  GET(CallsQ,CallsQ.CallingClass,CallsQ.CallingMethod)
  IF NOT ERRORCODE() !method calls others (has children)
    LOOP i = 1+POINTER(CallsQ) TO 1+RECORDS(CallsQ)
      IF UPPER(CLIP(CallsQ.CallingClass))=UPPER(CLIP(CallerClass)) AND |
         UPPER(CLIP(CallsQ.CallingMethod))=UPPER(CLIP(CallerMethod))
        IF (~ShowPrivate) AND CallsQ.CalleePrivate THEN CYCLE.
        IF (~ShowProtected) AND CallsQ.CalleeProtected THEN CYCLE.
        IF ExpandedAbove(Level)
          Children=True
        ELSE
          CallTreeQ.Level=Level
          CallTreeQ.Method=CallsQ.CalledMethod
          CallTreeQ.ClassMethodKey=UPPER(CLIP(CallsQ.CalledClass))&'.'&UPPER(CallsQ.CalledMethod)
          IF CallsQ.CallingClass<>CallsQ.CalledClass
            CallTreeQ.Method=CLIP(CallsQ.CalledClass)&'.'&CallTreeQ.Method
          END
          SetColor(CallTreeQ.NormalBG,CallTreeQ.SelectedBG,CallTreeQ.NormalFG,CallTreeQ.SelectedFG,CallsQ.CalleePrivate,CallsQ.CalleeVirtual,CallsQ.CalleeProtected)
          ADD(CallTreeQ)
          ASSERT(~ERRORCODE())
          Children=True
          ParentPos=POINTER(CallTreeQ)
          IF ~AddChildren(CallsQ.CalledClass,CallsQ.CalledMethod,Level)
            GET(CallTreeQ,ParentPos)
            ASSERT(~ERRORCODE())
            CallTreeQ.Level=ABS(CallTreeQ.Level)
            PUT(CallTreeQ)
            ASSERT(~ERRORCODE())
          END
        END
      ELSE
        BREAK
      END
      GET(CallsQ,i)
      IF ERRORCODE() THEN BREAK.
    END
  END
  RETURN Children

ExpandedAbove    PROCEDURE(SHORT Level)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
i       USHORT
  CODE
  LOOP i = 1 TO RECORDS(CallTreeQ)
    GET(CallTreeQ,i)
    IF NOT ERRORCODE()
      IF CallTreeQ.Level<0 AND CallTreeQ.ClassMethodKey=UPPER(CLIP(CallsQ.CalledClass))&'.'&UPPER(CallsQ.CalledMethod)
        CallTreeQ.Method=CLIP(CallsQ.CalledMethod)&' (expanded above)'
        IF CallsQ.CallingClass<>CallsQ.CalledClass
          CallTreeQ.Method=CLIP(CallsQ.CalledClass)&'.'&CallTreeQ.Method
        END
        CallTreeQ.Level=ABS(Level) !has no children because expanded above
        ADD(CallTreeQ)
        ASSERT(~ERRORCODE())
        RETURN True
      END
    END
  END
  RETURN False

SetColor PROCEDURE(*LONG NormalBG,*LONG SelectedBG,*LONG NormalFG,*LONG SelectedFG, BYTE Private, BYTE Virtual, BYTE Protected)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  CODE
  NormalBG     = COLOR:None
  SelectedBG   = COLOR:Yellow
  IF Private
    NormalFG   = COLOR:Red
    SelectedFG = COLOR:Red
  ELSIF Virtual
    NormalFG   = COLOR:Fuschia
    SelectedFG = COLOR:Fuschia
  ELSIF Protected
    NormalFG   = COLOR:Maroon
    SelectedFG = COLOR:Maroon
  ELSE
    NormalFG   = COLOR:None
    SelectedFG = COLOR:Black
  END